IncludeScript("murdermystery/RoleController.nut")
ClearGameEventCallbacks()
::MurdererList 			<- []
::MurdererList_Persist 	<- []
::BystanderList 		<- []

::PlayerManager <- Entities.FindByClassname(null, "tf_player_manager");
::GetPlayerUserID <- function(player){
    return NetProps.GetPropIntArray(PlayerManager, "m_iUserID", player.entindex());
}
::MaxPlayers <- MaxClients().tointeger()

Player_MIA <- function (UserID,) {
	foreach (user_ID in MurdererList) {
		if (user_ID == UserID) {
			MurdererList.remove(MurdererList.find(UserID))
			if (MurdererList.len() <= 0) {
				EndRound(2)
				return
			}
		}
	}

	foreach (user_ID in BystanderList) {
		if (user_ID == UserID) {
			BystanderList.remove(BystanderList.find(UserID))
			if (BystanderList.len() >= 2) {
				return
			}
			else if (BystanderList.len() <= 0) {
				EndRound(3)
				return
			}
		}
	}

	if (BystanderList.len() <= 1) {
		foreach (user_ID in BystanderList) {
			local player = GetPlayerFromUserID(user_ID)
			NetProps.SetPropInt(player, "m_bGlowEnabled", 1)
		}
	}
}
::PostListSher <-[]
::PostWinSher <- function(){
	local Player = PostListSher.pop()
	local slot0 = NetProps.GetPropEntityArray(Player, "m_hMyWeapons", 0)
	if (slot0 == null) return
	printl("pass >>>>>>>>>>>>>>>>>>>>")
	slot0.AddAttribute("fire rate bonus", 0.15, -1)
	slot0.AddAttribute("damage bonus", 0.5, -1)
	slot0.AddAttribute("mod max primary clip override", 25, -1)
	slot0.AddAttribute("maxammo secondary increased", 10, -1)
	//slot0.SetClip1(int amount)
	slot0.AddAttribute("Reload time decreased", 0, -1)
	Player.Weapon_Switch(slot0)
}
::PostListBy <-[]
::PostWinBy <- function(){
	local Player = PostListBy.pop()
	local slot0 = NetProps.GetPropEntityArray(Player, "m_hMyWeapons", 0)
	if (slot0 == null) return
	printl("pass >>>>>>>>>>>>>>>>>>>>")
	slot0.AddAttribute("damage bonus", 0.6, -1)
	slot0.AddAttribute("fire rate penalty", 2, -1)
	slot0.AddAttribute("Reload time decreased", 0, -1)
	slot0.AddAttribute("mod max primary clip override", 69, -1)
	slot0.AddAttribute("maxammo secondary increased", 500, -1)
	Player.Weapon_Switch(slot0)
}
EndRound <- function (Winner) {
	ClientPrint(null, 3, "Round is Over")
	foreach (user_ID in MurdererList_Persist) {
		local Player = GetPlayerFromUserID(user_ID)
		local plyname = NetProps.GetPropString(Player,"m_szNetname").tostring()
		if (Player == null) {return}
		Player.ForceChangeTeam(3, true)
		Player.ValidateScriptScope()
		local PlyClass = Player.GetScriptScope().MyClass
		ClientPrint(null, 3, plyname +"("+ PlyClass +")" + " Killed " + Player.GetScriptScope().MyKills + " Players") // murderer after round kills/scores
	}
	if (Winner == 2) {
		foreach (user_ID in BystanderList) {
			local Player = GetPlayerFromUserID(user_ID)
			Player.ValidateScriptScope()
			local slot0 = NetProps.GetPropEntityArray(Player, "m_hMyWeapons", 0)
			/*local slot1 = NetProps.GetPropEntityArray(Player, "m_hMyWeapons", 1)
			local slot2 = NetProps.GetPropEntityArray(Player, "m_hMyWeapons", 2)
			local slot3 = NetProps.GetPropEntityArray(Player, "m_hMyWeapons", 3)
			local slot4 = NetProps.GetPropEntityArray(Player, "m_hMyWeapons", 4)*/
			if (slot0 != null) {slot0.Kill()}
			printl("slot0 = "+slot0)
			/*if (slot1 != null) {slot0.Kill()}
			if (slot2 != null) {slot0.Kill()}
			if (slot3 != null) {slot0.Kill()}
			if (slot4 != null) {slot0.Kill()}*/
			
			local model = PrecacheModel("models/weapons/w_models/w_revolver.mdl")
    		local weapon = Entities.CreateByClassname("tf_weapon_revolver")
			NetProps.SetPropInt(weapon, "m_AttributeManager.m_Item.m_iItemDefinitionIndex", 24)
    		NetProps.SetPropBool(weapon, "m_AttributeManager.m_Item.m_bInitialized", true)
    		NetProps.SetPropBool(weapon, "m_bValidatedAttachedEntity", true)
    		NetProps.SetPropInt(weapon, "m_nModelIndex", model)
    		weapon.SetTeam(Player.GetTeam())
			weapon.DispatchSpawn()
    		NetProps.SetPropEntityArray(Player, "m_hMyWeapons", weapon, 0)
			Player.Weapon_Equip(weapon)
			if (Player.GetScriptScope().MyRole 	== "Sheriff") {
				EntFireByHandle(Player, "CallScriptFunction", "PostWinSher", 0, null, null)
				PostListSher.append(Player) 
			}
			else{
				EntFireByHandle(Player, "CallScriptFunction", "PostWinBy", 0, null, null)
				PostListBy.append(Player) 
			}
			
			
		}
	}
	else{
		foreach (user_ID in MurdererList) {
			
		}
	}

	local roundend = SpawnEntityFromTable("game_round_win", {
    	    	        TeamNum         = Winner, // 2 for red, 3 for blue, 1 for spec
    	    	        switch_teams    = 0,
    	    	        force_map_reset = 1,
    	    		}
				)
				EndRoundConvars()
				EntFireByHandle(roundend, "RoundWin", "", 0.4, roundend, roundend)
				//EntFireByHandle(roundend, "Kill", "", 10, roundend, roundend)
}

function OnGameEvent_player_death(params){
	local UserID 		= params.userid
	local deadplayer 	= GetPlayerFromUserID(UserID)
	//NetProps.SetPropBool(self, "m_bForcedSkin", false)
	AddThinkToEnt(deadplayer, null)
	deadplayer.ValidateScriptScope()
	if (deadplayer.GetScriptScope().MyRole == "Sheriff") {//drop gun
		SpawnSheriffGun("models/weapons/w_models/w_revolver.mdl", 1.2, deadplayer.GetOrigin(), deadplayer.GetAbsAngles())
	}

	Player_MIA(UserID)

	deadplayer.GetScriptScope().MyRole 	<- "spec"
	deadplayer.GetScriptScope().MyClass <- "null"
}

function OnGameEvent_player_activate(par) {
	local UserID = par.userid
	local Player = GetPlayerFromUserID(UserID)
	Player.ValidateScriptScope()
	Player.GetScriptScope().Karma <- 0
	printl("player joined. there karma is " + Player.GetScriptScope().Karma)
}

function OnGameEvent_player_disconnect(par) {
	local UserID 		= par.userid
	Player_MIA(UserID)
}

function OnPostSpawn() {
	Convars.SetValue("mp_friendlyfire", 	1)
	Convars.SetValue("mp_autoteambalance", 	0)
	Convars.SetValue("tf_dropped_weapon_lifetime", 	0)
	Convars.SetValue("sv_alltalk", 			1)
	Convars.SetValue("mp_respawnwavetime", 	1)
	Convars.SetValue("mp_teams_unbalance_limit", 0)
	Convars.SetValue("mp_disable_respawn_times", 0)
 	Convars.SetValue("mp_scrambleteams_auto", 0)
	Convars.SetValue("mp_winlimit", 0)
	Convars.SetValue("mp_maxrounds", 0)
	Convars.SetValue("mp_humans_must_join_team", "red")
	Convars.SetValue("sv_vote_issue_autobalance_allowed", "0")
	Convars.SetValue("sv_vote_issue_scramble_teams_allowed", "0")
}

//force class change
function OnGameEvent_player_spawn(params){
	local UserID 			= params.userid
	local respawnedplayer 	= GetPlayerFromUserID(params.userid)
	respawnedplayer.ValidateScriptScope()
	if (respawnedplayer != null && params.team == 0 ){
		respawnedplayer.GetScriptScope().MyRole 	<- "spec"
		respawnedplayer.GetScriptScope().MyClass 	<- "null"
	}
	else{
		respawnedplayer.ForceChangeTeam(2, true)
		respawnedplayer.SetPlayerClass(8)
		NetProps.SetPropInt(respawnedplayer, "m_bGlowEnabled", 0)
		respawnedplayer.SetCustomModel(null) // fixs hitboxs being miss aligned 
		NetProps.SetPropInt(respawnedplayer, "m_nForcedSkin", 0)
		local murder_cosmetic = null
		while(murder_cosmetic = Entities.FindByClassname(murder_cosmetic, "tf_wearable")){
			if (murder_cosmetic.GetOwner() == respawnedplayer){
			murder_cosmetic.SetTeam(2)
			}
		}
		NitWit(respawnedplayer)
		BystanderList.append(UserID)
		respawnedplayer.GetScriptScope().Karma = respawnedplayer.GetScriptScope().Karma + 1
	}
	
}

//killfeed mod
function OnScriptHook_OnTakeDamage(info) {
	info.attacker.ValidateScriptScope()
	info.const_entity.ValidateScriptScope()

	local MakeGhost = function(Player) {
		Player.AddCondEx(77, -1, null)
		Player.ValidateScriptScope()
		if (Player.GetScriptScope().MyRole == "Sheriff") {//drop gun
			SpawnSheriffGun("models/weapons/w_models/w_revolver.mdl", 1.2, Player.GetOrigin(), Player.GetAbsAngles())
		}
		AddThinkToEnt(Player, null)
		Player.GetScriptScope().MyRole 	<- "spec"
		Player.GetScriptScope().MyClass <- "null"
		
		Player_MIA(GetPlayerUserID(Player))
	}

	if (info.const_entity.GetClassname() == "player") { printl("Vplayer check passed")

		if (info.damage >= info.const_entity.GetHealth()) { printl(" ^ dmg = health check passed")

			if (info.attacker.GetClassname() == "player") { printl(" ^  ^ Aplayer check passed")

				if (info.const_entity.GetScriptScope().MyRole == info.attacker.GetScriptScope().MyRole) { printl(" ^  ^  ^ role compare check passed")
					info.max_damage = info.const_entity.GetHealth() -1
					/*
					info.early_out = true
					info.const_entity.SetHealth(1)*/
				}

				else{printl(" ^  ^  ^ role check failed")
					printl(info.const_entity.GetScriptScope().MyRole)
					printl(info.attacker.GetScriptScope().MyRole)
					if (info.const_entity.GetScriptScope().MyRole == "Bystander" && info.attacker.GetScriptScope().MyRole == "Sheriff") { printl(" ^  ^  ^ role compare 2 check passed")
						MakeGhost(info.attacker)
					}
					MakeGhost(info.const_entity)
				}
			}

			else if (info.attacker.GetClassname() == "trigger_hurt") { printl(" ^  ^ Trigger check passed")

				if (info.attacker.GetName().tostring() == "Murderer_Trigger"){ printl(" ^  ^  ^ Knife Trigger check passed")

					if (info.const_entity.GetScriptScope().MyRole == "Murderer") { printl(" ^  ^  ^  ^ Vplayer check passed")
						info.damage = info.const_entity.GetHealth()-1
					}

					else {printl(" ^  ^  ^  ^ Vplayer check failed")
						MakeGhost(info.const_entity)
					}
				}
				else{MakeGhost(info.const_entity)}
			}
			else {MakeGhost(info.const_entity)}
		}
	}
}

//commands
function OnGameEvent_player_say(params) {
	local Player = GetPlayerFromUserID(params.userid)
	Player.ValidateScriptScope()
	if (params.text == "!commands") {
		ClientPrint(Player, 3, "\x07ffffffListing GameMode Commands")
		ClientPrint(Player, 3, "\x07ffff00 - \x07ffffff!setclass -(to be implamented)")
		ClientPrint(Player, 3, "\x07ffff00 - \x07ffffff!getclasslist -(to be implamented)")
		ClientPrint(Player, 3, "\x07ffff00 - \x07ffffff!karma")
	}
	else if (params.text == "!setclass*") {
		ClientPrint(Player, 3, "yet to be added")
	}
	else if (params.text == "!getclasslist*") {
		ClientPrint(Player, 3, "yet to be added")
		//if (MurdererRolesList.len() != 0 && params.text == "!getclasslist murderer*") {MurdererRolesList}
	}
	else if (params.text == "!karma") {
		ClientPrint(Player, 3, "your karma level is [" + Player.GetScriptScope().karma + "]")
	}
}

__CollectGameEventCallbacks(this)